<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
 <template slot-scope="scope" slot="avatar">

      <img style="width: 70px; height: 50px; " :src="scope.row.avatar" :fit="fit" @click="openView(scope.row.avatar)">
    </template>
    </avue-crud>


  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/guosen/useragenter";
  import {mapGetters} from "vuex";

  export default {
    props:{
      agenterId:{}
    },
    data() {
      return {

        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          menu: false,
          addBtn: false,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [


 {
              label: "用户昵称",
              prop: "nickName",
              search: true,
              width: 200,
              rules: [{
                required: true,
                message: "请输入用户昵称",
                trigger: "blur"
              }]
            },
            {
              label: "用户头像",
              prop: "avatar",
              width: 100,
              slot: true,
              rules: [{
                required: true,
                message: "请输入用户头像",
                trigger: "blur"
              }]
            },
            {
              label: "手机号",
              prop: "phone",
              search: true,
              rules: [{
                required: true,
                message: "请输入手机号",
                trigger: "blur"
              }]
            },
            {
              label: "性别",
              prop: "gender",
              type: "select",
              search: true,
              dicData: [
                {
                  label: "未知",
                  value: 0
                },
                {
                  label: "男",
                  value: 1
                },
                {
                  label: "女",
                  value:  2
                }
              ],
              rules: [{
                required: true,
                message: "请输入0：未知 1：男 2：女",
                trigger: "blur"
              }]
            },

           {
             label: "所在省份",
             prop: "province",
             search: true,
             span: 22,
             row: true,
             type: "select",
              cascaderItem: ["city"],
             dicUrl: "/api/cyzh-system/sysarea/list?size=1000&layerNumber=1",
             props:{
               label: "name",
               value: "pinyin"
             },
             dicFormatter: (res) =>{
               return res.data.records;
             },

             labelWidth: 150,
             display: true,

             rules: [{
               required: true,
               message: "请输入代理省份",
               trigger: "blur"
             }]
           },
           {
             label: "所在城市",
             search: true,
             prop: "city",
             type: "select",
             dicUrl: `/api/cyzh-system/sysarea/getCityByProvincePinyin?provincePinyin={{key}}`,
             props:{
               label: "name",
               value: "pinyin"
             },
             dicFormatter: (res) =>{
               return res.data;
             },
             span: 22,
             row: true,
             labelWidth: 150,
             display: true,
             rules: [{
               required: true,
               message: "请输入代理城市",
               trigger: "blur"
             }]
           },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.useragenter_add, false),
          viewBtn: this.vaildData(this.permission.useragenter_view, false),
          delBtn: this.vaildData(this.permission.useragenter_delete, false),
          editBtn: this.vaildData(this.permission.useragenter_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      openView(url) {
        var data = [{
          thumbUrl: url,
          url: url
        }];
        this.$ImagePreview(data, 0);
      },
      init(){
        this.query.agenterId = this.agenterId;
        this.onLoad(this.page,this.query);
      },
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
